/***************************************************************************
                          filegest.cpp  -  description            
                                      -------------------                     
    begin                : lun mai  3 20:19:52 CEST 1999
                                           
    copyright            : (C) 1999 by Franois Dupoux                         
    email                : fdupoux@lemel.fr                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/


// ========================================================================================
// Return the name of the file, not the path, then only file name + extension
// Paramtres:...........* szName: pointer (char *) to the destiation filename
//                       * szFullPath: pointer (char *) to the full path of the file
// Valeurs retournes:...*  0 if success
//                       * -1 if error
// ========================================================================================
int GetFileName(char *szName, char *szFullPath);

// ========================================================================================
// Return the path of the file, not the name, then for example: "/root/file.txt" --> "/root"
// Paramtres:...........* szPath: pointer (char *) to the destiation filepath
//                       * szFullPath: pointer (char *) to the full path of the file
// Valeurs retournes:...*  0 if success
//                       * -1 if error
// ========================================================================================
int GetFilePath(char *szPath, char *szFullPath);

// ========================================================================================
// Return the CRC of a file
// Paramtres:...........* szFilename: Path of the file we need the CRC
//                       * nFileCrc: Adresse of the Int where the CRC must be written
// Valeurs retournes:...*  0 if success
//                       * -1 if error
// ========================================================================================
int CalculateCRCOfFile(char *szFilename, unsigned int *nFileCRC);

// ========================================================================================
// Create all directories of the path szfullPath
// Paramtres:...........* szDirectory: pointer to the filepath of the directory to create
// Valeurs retournes:...*  0 if success
//                       * -1 if error
// ========================================================================================
int CreateAllDirsOfPath(char *szDirectory);




